﻿using CallableVEE;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Threading.Tasks;

namespace OpenTap.Plugins.VeeIntegration
{
    /// <summary>
    /// The .Net type data that stores the type information retrieved from the VEE user function. E.g. function name, input/output parameters, etc.
    /// </summary>
    class VeeTypeData : ITypeData
    {
        IMemberData[] customMemberDataCache;
        public VeeDescriptor VeeDescriptor { get; }

        public VeeTypeData(VeeDescriptor descriptor)
        {
            VeeDescriptor = descriptor;
            var attributes = new List<object>();

            // display attribute from VEE user function
            var displayAttribute = new DisplayAttribute(VeeDescriptor.FunctionName, VeeDescriptor.Description, null, -10000, false, new string[] { "VEE", VeeDescriptor.FileName });
            attributes.Add(displayAttribute);

            // return the attributes of base type and derived type
            Attributes = attributes.Concat(BaseType.Attributes);

            Name = GenerateTypeDataName(VeeDescriptor);
        }

        public IEnumerable<object> Attributes { get; }

        public string Name { get; }

        public IEnumerable<IMemberData> GetMembers()
        {
            var baseMembers = BaseType.GetMembers();

            // Must cache the custom MemberData. Otherwise, new custom MemberData gets created on every function called.
            // OpenTap uses object referencing in GUI and step settings connection.
            // Creating new custom MemberData on every request will cause lost connection and unexpected behaviour. 
            return baseMembers.Concat(customMemberDataCache ?? (customMemberDataCache = getCustomMembers().ToArray()));
        }

        /// <summary>
        /// The custom members(properties) of this type are generated by request here.
        /// </summary>
        /// <returns></returns>
        IEnumerable<IMemberData> getCustomMembers()
        {
            foreach (var arg in VeeDescriptor.Arguments)
            {
                // The VeeColumnDisplayMember must be inserted before any other VeeMemberData generated from the same argument.
                yield return new VeeColumnDisplayMember(arg, this);
                yield return new TypeAndShapeRecord(arg, this);
                var dataType = DataTypeHelper.GetOpenTapDataType(arg.DataType);
                var dataShape = DataTypeHelper.GetOpenTapDataShape(arg.DataShape);

                //Check for supported dataTypes by OpenTap
                if (dataType == OpenTapDataType.NotSupported || (arg.Input && arg.DataType == VeeDataType.veeTypeNil))
                    throw new Exception($"The selected datatype {arg.DataType} of the input variable {arg.Name} in step {VeeDescriptor.FunctionName} is not supported in OpenTap");
                //Check for supported dataShapes by OpenTap
                if (dataShape == OpenTapDataShape.NotSupported)
                    throw new Exception($"VEE.{VeeDescriptor.FileName}.{VeeDescriptor.FunctionName}.{arg.Name}: Input dataShape \"{arg.DataShape}\" is not supported in OpenTap");

                if (dataType == OpenTapDataType.Any && dataShape == OpenTapDataShape.Any)
                {
                    // when type and shape are 'Any', we need to instantiate all supported types(default dropdown list of supported types is AvailableDataTypesForArray1D) and shapes
                    yield return new VeeDataTypeSelector(arg, this, OpenTapDataShape.Array1D.ToString());
                    foreach (var shapeCases in DataTypeHelper.CaseSupportedTypes)
                    {
                        yield return new VeeDataShapeSelector(arg, this, shapeCases);
                    }
                    foreach (var dotNetVeeTypePair in DataTypeHelper.DotNetVeeTypeMatchingTable)
                    {
                        yield return new VeeMemberData(arg, this, dotNetVeeTypePair);
                    }
                }
                else if (dataType == OpenTapDataType.Any)
                {
                    // when type is 'Any' but shape is not 'Any', we need to instantiate all supported types for the particular shape

                    //Using dataShape as one of the argument to VeeDatatypeSelector to provide the user with the specific list of datatypes based on the selected shape.
                    yield return new VeeDataTypeSelector(arg, this, dataShape.ToString(), true);

                    foreach (var shapeCases in DataTypeHelper.CaseSupportedTypes)
                    {
                        if (shapeCases.Value.Item2.Contains(dataShape))
                            yield return new VeeDataShapeSelector(arg, this, shapeCases, false);
                    }
                    foreach (var dotNetVeeTypePair in DataTypeHelper.GetMatchingTypePair(dataShape))
                    {
                        yield return new VeeMemberData(arg, this, dotNetVeeTypePair);
                    }
                }
                else if (dataShape == OpenTapDataShape.Any)
                {
                    // when shape is 'Any' but type is not 'Any', we need to instantiate all supported shapes for the particular type
                    yield return new VeeDataTypeSelector(arg, this, OpenTapDataShape.Array1D.ToString(), false);
                    foreach (var shapeCases in DataTypeHelper.CaseSupportedTypes)
                    {
                        if (shapeCases.Value.Item1.Contains(dataType))
                        {
                            yield return new VeeDataShapeSelector(arg, this, shapeCases);
                            break;
                        }
                    }
                    foreach (var dotNetVeeTypePair in DataTypeHelper.GetMatchingTypePair(dataType))
                    {
                        yield return new VeeMemberData(arg, this, dotNetVeeTypePair);
                    }
                }
                else
                {
                    yield return new VeeDataTypeSelector(arg, this, OpenTapDataShape.Array1D.ToString(), false);
                    foreach (var shapeCases in DataTypeHelper.CaseSupportedTypes)
                    {
                        if (shapeCases.Value.Item1.Contains(dataType))
                        {
                            yield return new VeeDataShapeSelector(arg, this, shapeCases, false);
                            break;
                        }
                    }
                    var dotNetVeeTypePair = DataTypeHelper.GetMatchingTypePair(dataType, dataShape);
                    if (dotNetVeeTypePair.Key != null)
                        yield return new VeeMemberData(arg, this, dotNetVeeTypePair);
                }
            }
        }

        public IMemberData GetMember(string name)
        {
            var mem = GetMembers().FirstOrDefault(x => x.Name == name);
            return mem;
        }

        public object CreateInstance(object[] arguments)
        {
            return new VeeTestStep(this);
        }

        public ITypeData BaseType => TypeData.FromType(typeof(VeeTestStep));

        public bool CanCreateInstance => true;

        // Equals / GetHashCode must be overridden, otherwise these new types will not work well.
        public override bool Equals(object obj)
        {
            if (obj is VeeTypeData otherType)
            {
                return otherType.Name == Name;
            }
            return base.Equals(obj);
        }

        public override int GetHashCode() => Name.GetHashCode() * 3128321;

        public static string GenerateTypeDataName(VeeDescriptor descriptor)
        {
            return $"{VeeTypeDataProvider.PREFIX}{descriptor.FileName}:{descriptor.FunctionName}";
        }
    }
}